//by Bon_Inf*


BON_CONSTRUCTION_PATH = "construction\";

WaitUntil{(isDedicated || not isNull player) && not isNil "TFOR_INIT"};


if(isServer) then {
	"tfor_vehicle_constructed" addpublicvariableeventhandler {
		[_this select 1] execFSM "fsm\vehicle_lifecycle.fsm";
	};
};

if(isDedicated) exitWith{};


_coin = _this select 0;
_vehicletypes = _this select 1;


// type of fortification for constr. site bounds
_barriertype = "Land_BagFenceShort"; //"Land_HBarrier_large";



/************************** construction area ****************************/
_areasize = 50;
if(count _this > 3) then {
	if(typename (_this select 2) != "SCALAR" || typename (_this select 3) != "BOOL") exitWith{};

	_areasize = (_this select 2) / 2;

	if(not (_this select 3)) exitWith{};

	// create boundaries around the site
	_pos = position _coin;
	_radius = _areasize;
	_ang = 0;

	//determine required number barrier objects
	_circumference = 2*pi*_radius;
	_dummybarrier = _barriertype createVehicleLocal [0,0,0];
	_size = sizeof typeof _dummybarrier * 0.75;
	_count = 1 max ceil (_circumference / _size);
	deleteVehicle _dummybarrier;

	_inc = 360/_count; 
	_barriers = [];

	for "_i" from 1 to _count do {

		_ang = _inc * _i;

		_a = (_pos select 0)+(sin(_ang)*_radius);
		_b = (_pos select 1)+(cos(_ang)*_radius);

		_barrier = _barriertype createVehicleLocal [_a,_b,0];
		_barriers = _barriers + [_barrier];

		_barrier setpos [_a,_b,0]; _barrier setdir _ang;
		_barrier allowdamage false;
		_barrier enablesimulation false;
	};

	// create an entrance
	_min_anglediff = 359;
	_barrier_index = 0;
	for "_i" from 0 to (count _barriers - 1) do {
		if(abs (getdir (_barriers select _i) - getdir _coin) < _min_anglediff) then {
			_min_anglediff = abs (getdir (_barriers select _i) - getdir _coin);
			_barrier_index = _i;
		};
	};

	_entrancesize = floor ((_count / 8)/2);
	for "_i" from (-1 * _entrancesize) to _entrancesize do {
		deleteVehicle (_barriers select ((_barrier_index + _i) % count _barriers));
	};
};
_coin setvariable ["BIS_COIN_areasize",[_areasize,50]];



/************************ normal vehicle funds *************************/
tfor_vehiclefunds = 0;
_special_funds = 
	switch _vehicletypes do {
		case "land" : {tfor_max_vehicle_at_once};
		case "air" : {tfor_max_aircraft_at_once};
		default {0};
	};

private ["_onstart"];
call compile format["_onstart = {
	_logic = _this select 0;
	tfor_vehiclefunds = {name player == (_x getVariable 'tfor_vehicleconstructor') && alive _x} count nearestObjects [[position _logic select 0, position _logic select 1, 0],['All'],%2];
	tfor_vehiclefunds = 0 max (%1 - tfor_vehiclefunds);
}",_special_funds, _areasize];
_coin setvariable ["BIS_COIN_onstart",_onstart];



/************************ construction handle *************************/
_coin setvariable ["BIS_COIN_onconstruct",{
	_logic = _this select 0;
	_vehicle = _this select 1;

	tfor_vehicle_constructed = _vehicle;
	if(isServer) then {
		[_vehicle] execFSM "fsm\vehicle_lifecycle.fsm";
	} else {
		publicVariable "tfor_vehicle_constructed";
	};

	if(typeof _vehicle in tfor_advanced_vehicle_list) then {
		publicvariable "tfor_adv_vehicle_funds";
	};

	if(typeof _vehicle in tfor_advanced_aircraft_list) then {
		publicvariable "tfor_adv_aircraft_funds";
	};

	if(not (typeof _vehicle in (tfor_advanced_aircraft_list + tfor_advanced_vehicle_list))) then {
		_vehicle setVariable ["tfor_vehicleconstructor",name player];
	};
}];

_coin setvariable ["BIS_COIN_rules",[tfor_friendly_side]];




[_coin] execVM (BON_CONSTRUCTION_PATH + format["vehicles_%1.sqf",_vehicletypes]);