// by Bon_Inf*

_caller = _this select 1;
_unit = vehicle _caller;
_pos = getPos _unit;
if(_pos select 2 > 0.5) exitWith{};


// get the vehicle seat of the caller. Resupply aborts if the seat changes.
BON_REARM_GETCALLERSEAT = nil;
switch _caller do {
	case driver _unit : {BON_REARM_GETCALLERSEAT = {driver _this}};
	case gunner _unit : {BON_REARM_GETCALLERSEAT = {gunner _this}};
	case commander _unit : {BON_REARM_GETCALLERSEAT = {commander _this}};
};
if(isNil "BON_REARM_GETCALLERSEAT") exitWith{hint "cargo can't resupply this vehicle."};




/******* Repairing vehicle ********/
[_unit,_pos,_caller] spawn {

	_unit = _this select 0;
	_pos = _this select 1;
	_caller = _this select 2;

	if(not isNil {_unit getVariable "bon_rearm_repairing"}) exitWith{};
	_unit setVariable ["bon_rearm_repairing",true];

	_dmge = getDammage (vehicle _unit);

	_repairtime = (_dmge*60) max 1;
	_repairvalue_per_step = _dmge/_repairtime;

	_unit vehicleChat "Repairing...";

	while{_unit distance _pos < 2.75 && getPos _unit select 2 < 0.5 && damage _unit > 0 && _caller == _unit call BON_REARM_GETCALLERSEAT} do {
		_unit setDamage ((damage vehicle _unit) - _repairvalue_per_step);
		sleep 1;
	};
	if(damage _unit == 0) then {_unit vehicleChat "Repairing complete!"}
	else{_unit vehicleChat "Repairing cancelled."};
	_unit setVariable ["bon_rearm_repairing",nil];
};




/******* Refueling vehicle *********/
[_unit,_pos,_caller] spawn {

	_unit = _this select 0;
	_pos = _this select 1;
	_caller = _this select 2;

	if(not isNil {_unit getVariable "bon_rearm_refueling"}) exitWith{};
	_unit setVariable ["bon_rearm_refueling",true];

	_fuel_to_fill = 1 - (fuel _unit);

	_refueltime = 1 max (_fuel_to_fill*60);
	_refuelvalue_per_step = _fuel_to_fill/_refueltime;

	_unit vehicleChat "Refueling...";

	while{_unit distance _pos < 2.75 && getPos _unit select 2 < 0.5 && fuel _unit < 0.99 && _caller == _unit call BON_REARM_GETCALLERSEAT} do {
		_unit setFuel (fuel _unit) + _refuelvalue_per_step;
		sleep 1;
	};
	if(fuel _unit >= 0.99) then {_unit vehicleChat "Refueling complete!"}
	else{_unit vehicleChat "Refueling cancelled."};
	_unit setVariable ["bon_rearm_refueling",nil];
};




/******** Rearming mounted weapons *******/
[_unit,_pos,_caller] spawn {

	_unit = _this select 0;
	_pos = _this select 1;
	_caller = _this select 2;

	if(not isNil {_unit getVariable "bon_rearm_rearming"}) exitWith{};
	_unit setVariable ["bon_rearm_rearming",true];

	_reload_timefactor = 10; // seconds each mag requires when refilling


	// first we gather all magazines left,
	// subtracting the (assumed to be) used mag
	_magazines_left = [];
	{
		_mag = _x;
		if(!(_mag in _magazines_left)) then {
			_count = {_x == _mag} count magazines _unit;
			for "_i" from 1 to (_count - 1) do{_magazines_left = _magazines_left + [_x]};
		};
	} foreach magazines _unit;


	// then we check how many magazines the vehicle can/should carry
	_total_magazines = [];
	_turretcount = count (configFile >> "CfgVehicles" >> typeof _unit >> "turrets");

	for "_i" from 0 to (_turretcount - 1) do {
		_turret = (configFile >> "CfgVehicles" >> typeof _unit >> "turrets") select _i;
		_total_magazines = _total_magazines + getArray (_turret >> "magazines");				
	};


	// we take the diff to get the magazines that need to be refilled
	{
		_mag = _x;
		for "_i" from 0 to (count _total_magazines - 1) do {
			if((_total_magazines select _i) == _mag) exitWith {
				_total_magazines set [_i, ""];
			};
		} foreach _total_magazines;
	} foreach _magazines_left;
	_magazines_to_fill = _total_magazines - [""];



	// here we go. now just to be on the safe side,
	// we'll set vehicle ammo to 1 first,
	// then remove the mags to fill, and add them step by step.
	// lol.
	_unit setVehicleAmmo 1;
	{
		_unit removeMagazines _x;
	} foreach _magazines_to_fill;


	{
		_displayname = getText (configFile >> "CfgMagazines" >> _x >> "displayname");
		if(_displayname == "") then {_displayname = _x};
		_unit vehicleChat format["Rearming magazine %1...",_displayname];

		_time = time;
		while{time - _time < _reload_timefactor && _unit distance _pos < 2.75 && getPos _unit select 2 < 0.5 && _caller == _unit call BON_REARM_GETCALLERSEAT} do{sleep 0.1};
		if(time - _time < _reload_timefactor) exitWith{};
		_unit addMagazine _x;
	} foreach _magazines_to_fill;

	if(_unit distance _pos < 2.75 && getPos _unit select 2 < 0.5 && _caller == _unit call BON_REARM_GETCALLERSEAT) then {
		_unit vehicleChat "Rearming complete!"
	}
	else {_unit vehicleChat "Rearming cancelled."};
	_unit setVariable ["bon_rearm_rearming",nil];
};